/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: MM_ConcurrentPrepareCardTableTaskPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the MM_ConcurrentPrepareCardTableTaskPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=MM_ConcurrentPrepareCardTableTask.class)
public class MM_ConcurrentPrepareCardTableTaskPointer extends MM_ParallelTaskPointer {

	// NULL
	public static final MM_ConcurrentPrepareCardTableTaskPointer NULL = new MM_ConcurrentPrepareCardTableTaskPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected MM_ConcurrentPrepareCardTableTaskPointer(long address) {
		super(address);
	}

	public static MM_ConcurrentPrepareCardTableTaskPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static MM_ConcurrentPrepareCardTableTaskPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static MM_ConcurrentPrepareCardTableTaskPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new MM_ConcurrentPrepareCardTableTaskPointer(address);
	}

	public MM_ConcurrentPrepareCardTableTaskPointer add(long count) {
		return MM_ConcurrentPrepareCardTableTaskPointer.cast(address + (MM_ConcurrentPrepareCardTableTask.SIZEOF * count));
	}

	public MM_ConcurrentPrepareCardTableTaskPointer add(Scalar count) {
		return add(count.longValue());
	}

	public MM_ConcurrentPrepareCardTableTaskPointer addOffset(long offset) {
		return MM_ConcurrentPrepareCardTableTaskPointer.cast(address + offset);
	}

	public MM_ConcurrentPrepareCardTableTaskPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public MM_ConcurrentPrepareCardTableTaskPointer sub(long count) {
		return MM_ConcurrentPrepareCardTableTaskPointer.cast(address - (MM_ConcurrentPrepareCardTableTask.SIZEOF * count));
	}

	public MM_ConcurrentPrepareCardTableTaskPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public MM_ConcurrentPrepareCardTableTaskPointer subOffset(long offset) {
		return MM_ConcurrentPrepareCardTableTaskPointer.cast(address - offset);
	}

	public MM_ConcurrentPrepareCardTableTaskPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public MM_ConcurrentPrepareCardTableTaskPointer untag(long mask) {
		return MM_ConcurrentPrepareCardTableTaskPointer.cast(address & ~mask);
	}

	public MM_ConcurrentPrepareCardTableTaskPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return MM_ConcurrentPrepareCardTableTask.SIZEOF;
	}

	// Implementation methods

	// CardAction _action
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="__actionOffset_", declaredType="CardAction")
	public long _action() throws CorruptDataException {
		if (CardAction.SIZEOF == 1) {
			return getByteAtOffset(MM_ConcurrentPrepareCardTableTask.__actionOffset_);
		} else if (CardAction.SIZEOF == 2) {
			return getShortAtOffset(MM_ConcurrentPrepareCardTableTask.__actionOffset_);
		} else if (CardAction.SIZEOF == 4) {
			return getIntAtOffset(MM_ConcurrentPrepareCardTableTask.__actionOffset_);
		} else if (CardAction.SIZEOF == 8) {
			return getLongAtOffset(MM_ConcurrentPrepareCardTableTask.__actionOffset_);
		} else {
			throw new IllegalArgumentException("Unexpected ENUM size in core file");
		}
	}

	// CardAction _action
	public EnumPointer _actionEA() throws CorruptDataException {
		return EnumPointer.cast(nonNullFieldEA(MM_ConcurrentPrepareCardTableTask.__actionOffset_), CardAction.class);
	}

	// MM_ConcurrentCardTableForWC* _cardTable
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="__cardTableOffset_", declaredType="MM_ConcurrentCardTableForWC*")
	public MM_ConcurrentCardTableForWCPointer _cardTable() throws CorruptDataException {
		return MM_ConcurrentCardTableForWCPointer.cast(getPointerAtOffset(MM_ConcurrentPrepareCardTableTask.__cardTableOffset_));
	}

	// MM_ConcurrentCardTableForWC* _cardTable
	public PointerPointer _cardTableEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(MM_ConcurrentPrepareCardTableTask.__cardTableOffset_));
	}

	// Card* _firstCard
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="__firstCardOffset_", declaredType="Card*")
	public U8Pointer _firstCard() throws CorruptDataException {
		return U8Pointer.cast(getPointerAtOffset(MM_ConcurrentPrepareCardTableTask.__firstCardOffset_));
	}

	// Card* _firstCard
	public PointerPointer _firstCardEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(MM_ConcurrentPrepareCardTableTask.__firstCardOffset_));
	}

	// Card* _lastCard
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="__lastCardOffset_", declaredType="Card*")
	public U8Pointer _lastCard() throws CorruptDataException {
		return U8Pointer.cast(getPointerAtOffset(MM_ConcurrentPrepareCardTableTask.__lastCardOffset_));
	}

	// Card* _lastCard
	public PointerPointer _lastCardEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(MM_ConcurrentPrepareCardTableTask.__lastCardOffset_));
	}

}
